<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="会议时间" prop="meetingDate">
        <el-date-picker clearable size="small" style="width: 200px"
          v-model="queryParams.meetingDate"
          type="date"
          value-format="yyyy-MM-dd"
          placeholder="选择会议时间">
        </el-date-picker>
      </el-form-item>
      <el-form-item label="会议地点" prop="venue">
        <el-input
          v-model="queryParams.venue"
          placeholder="请输入会议地点"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="主题" prop="subject">
        <el-input
          v-model="queryParams.subject"
          placeholder="请输入主题"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="cyan" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['plant:dailyMeeting:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['plant:dailyMeeting:edit']"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['plant:dailyMeeting:remove']"
        >删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="primary"
          icon="el-icon-edit"
          size="mini"
          @click="handleConfig"
          v-hasPermi="['plant:dailyMeeting:edit']"
        >调度会议配置</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="primary"
          icon="el-icon-edit"
          size="mini"
          @click="handleEmail"
          v-hasPermi="['plant:dailyMeeting:edit']"
        >邮件配置</el-button>
      </el-col>
<!--      <el-col :span="1.5">-->
<!--        <el-button-->
<!--          type="warning"-->
<!--          icon="el-icon-download"-->
<!--          size="mini"-->
<!--          @click="handleExport"-->
<!--          v-hasPermi="['plant:dailyMeeting:export']"-->
<!--        >导出</el-button>-->
<!--      </el-col>-->
	  <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="dailyMeetingList" @selection-change="handleSelectionChange" :height="clientHeight" border>
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="会议时间" align="center" prop="meetingDate" width="100">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.meetingDate, '{y}-{m}-{d}') }}</span>
        </template>
      </el-table-column>
      <el-table-column label="记录人" align="center" prop="recorder" :show-overflow-tooltip="true"/>
      <el-table-column label="会议地点" align="center" prop="venue" :show-overflow-tooltip="true"/>
      <el-table-column label="主题" align="center" prop="subject" :show-overflow-tooltip="true"/>
      <el-table-column label="邮件状态" align="center" width="120" prop="emailStatus" >
        <template slot-scope="scope">
          <el-tag v-if="scope.row.emailStatus == 1" size="small" type="success">已发送</el-tag>
          <el-tag v-else-if="scope.row.emailStatus == 0" size="small" type="info">未发送</el-tag>
          <el-tag v-else-if="scope.row.emailStatus == -1" size="small" type="danger">发送失败</el-tag>
        </template>
      </el-table-column>
      <el-table-column label="所属部门" align="center" prop="deptName" width="100" :show-overflow-tooltip="true"/>
      <el-table-column label="操作" align="center" fixed="right" width="300" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-view"
            @click="wordView(scope.row.wordUrl)"
          >预览</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-download"
            @click="handleDownload(scope.row)"
          >{{ $t('下载') }}</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['plant:dailyMeeting:edit']"
          >修改</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-mail"
            @click="handleMail(scope.row)"
            v-hasPermi="['plant:dailyMeeting:edit']"
          >发送邮件</el-button>

        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改调度会议对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="抄送人" >
          <el-select
                     v-model="ccerList"
                     placeholder="请选择抄送人"
                     style="width: 100%"
                     filterable
                     multiple
          >
            <el-option
              v-for="dict in principalList"
              :key="dict.staffId"
              :label="dict.nickName"
              :value="dict.staffId">
            </el-option>
          </el-select>
        </el-form-item>

      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
      <!-- 用户导入对话框 -->
      <el-dialog :title="upload.title" :visible.sync="upload.open" width="400px" append-to-body>
          <el-upload
                  ref="upload"
                  :limit="1"
                  accept=".xlsx, .xls"
                  :headers="upload.headers"
                  :action="upload.url + '?updateSupport=' + upload.updateSupport"
                  :disabled="upload.isUploading"
                  :on-progress="handleFileUploadProgress"
                  :on-success="handleFileSuccess"
                  :auto-upload="false"
                  drag
          >
              <i class="el-icon-upload"></i>
              <div class="el-upload__text">
                  将文件拖到此处，或
                  <em>点击上传</em>
              </div>
              <div class="el-upload__tip" slot="tip">
                  <el-checkbox v-model="upload.updateSupport" />是否更新已经存在的用户数据
                  <el-link type="info" style="font-size:12px" @click="importTemplate">下载模板</el-link>
              </div>
              <div class="el-upload__tip" style="color:red" slot="tip">提示：仅允许导入“xls”或“xlsx”格式文件！</div>
          </el-upload>
          <div slot="footer" class="dialog-footer">
              <el-button type="primary" @click="submitFileForm">确 定</el-button>
              <el-button @click="upload.open = false">取 消</el-button>
          </div>
      </el-dialog>
    <Yulan ref="yulanRef"></Yulan>
  </div>
</template>

<script>
import { listDailyMeeting,sendMail, getDailyMeeting, delDailyMeeting, addDailyMeeting, updateDailyMeeting, exportDailyMeeting, importTemplate} from "@/api/plant/dailyMeeting";
import { treeselect } from "@/api/system/dept";
import { getToken } from "@/utils/auth";
import Treeselect from "@riophae/vue-treeselect";
import "@riophae/vue-treeselect/dist/vue-treeselect.css";
import {listPostUser} from "@/api/system/user";
import Yulan from '@/views/components/yulan/index.vue'

export default {
  name: "DailyMeeting",
  components: { Treeselect,Yulan },
  data() {
    return {
      // 遮罩层
      loading: true,
      ccerList: null,
      principalList: null,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: false,
      // 总条数
      total: 0,
      // 调度会议表格数据
      dailyMeetingList: [],
      // 弹出层标题
      title: "",
      // 部门树选项
      deptOptions: undefined,
      clientHeight:300,
      // 是否显示弹出层
      open: false,
        // 用户导入参数
        upload: {
            // 是否显示弹出层（用户导入）
            open: false,
            // 弹出层标题（用户导入）
            title: "",
            // 是否禁用上传
            isUploading: false,
            // 是否更新已经存在的用户数据
            updateSupport: 0,
            // 设置上传的请求头部
            headers: { Authorization: "Bearer " + getToken() },
            // 上传的地址
            url: process.env.VUE_APP_BASE_API + "/plant/dailyMeeting/importData"
        },
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 20,
        recorder: null,
        meetingNo: null,
        meetingDate: null,
        venue: null,
        subject: null,
        attendCracker: null,
        attendCtm: null,
        attendCta: null,
        attendLab: null,
        safetyTopic: null,
        deptId: null
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
      }
    };
  },
  watch: {
        // 根据名称筛选部门树
        deptName(val) {
            this.$refs.tree.filter(val);
        }
   },
  created() {
      //设置表格高度对应屏幕高度
      this.$nextTick(() => {
          this.clientHeight = document.body.clientHeight -250
      })
    this.getList();
    this.getTreeselect();
    listPostUser({}).then(response => {
      this.principalList = response;})
  },
  methods: {
    /** 查询调度会议列表 */
    getList() {
      this.loading = true;
      listDailyMeeting(this.queryParams).then(response => {
        this.dailyMeetingList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
     /** 查询部门下拉树结构 */
     getTreeselect() {
          treeselect().then(response => {
              this.deptOptions = response.data;
          });
     },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        recorder: null,
        meetingNo: null,
        meetingDate: null,
        venue: null,
        subject: null,
        attendCracker: null,
        attendCtm: null,
        attendCta: null,
        attendLab: null,
        safetyTopic: null,
        delFlag: null,
        createrCode: null,
        createdate: null,
        updaterCode: null,
        updatedate: null,
        deptId: null,
        optMode: null,
        optItem: null,
        split: null,
        pgu: null,
        aeu: null,
        optItemList: [],
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.title = "添加调度会议";
      this.$router.push("/plant/meeting/detail/0");

    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids
      // getDailyMeeting(id).then(response => {
      //   this.form = response.data;
      //   this.open = true;
      //   this.title = "修改调度会议";
      // });
      this.$router.push("/plant/meeting/detail/" + id);
    },
    handleConfig(){
      this.$router.push("/plant/meeting/dailyMeetingConfig");
    },
    handleEmail(){
      this.$router.push("/plant/meeting/dailyMeetingEmail");
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.id != null) {
            updateDailyMeeting(this.form).then(response => {
              this.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$confirm('是否确认删除?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return delDailyMeeting(ids);
        }).then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        })
    },
    /** 文件下载处理 */
    handleDownload(row) {
      var name = row.wordUrl;
      var url = row.wordUrl;
      var suffix = url.substring(url.lastIndexOf("."), url.length);
      const a = document.createElement('a')
      a.setAttribute('download', name)
      a.setAttribute('target', '_blank')
      a.setAttribute('href', process.env.VUE_APP_BASE_API + url)
      a.click()
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm('是否确认导出所有调度会议数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return exportDailyMeeting(queryParams);
        }).then(response => {
          this.download(response.msg);
        })
    },
      /** 导入按钮操作 */
      handleImport() {
          this.upload.title = "用户导入";
          this.upload.open = true;
      },
      /** 下载模板操作 */
      importTemplate() {
          importTemplate().then(response => {
              this.download(response.msg);
          });
      },
      // 文件上传中处理
      handleFileUploadProgress(event, file, fileList) {
          this.upload.isUploading = true;
      },
      // 文件上传成功处理
      handleFileSuccess(response, file, fileList) {
          this.upload.open = false;
          this.upload.isUploading = false;
          this.$refs.upload.clearFiles();
          this.$alert(response.msg, "导入结果", { dangerouslyUseHTMLString: true });
          this.getList();
      },
      // 提交上传文件
      submitFileForm() {
          this.$refs.upload.submit();
      },
      wordView(url){
        // 通过ref引用子组件
        const yulan = this.$refs.yulanRef;
        // 调用子组件的方法并传递参数
        yulan.handleSee("调度会议" , url);
      },
      handleMail(row){
        let parm = {id: row.id}
        sendMail(parm).then(response => {
          this.getList();
          this.msgSuccess("发送成功");
        });
      },
    handleCc(row){
      this.reset();
      this.ccerList = null
      this.title = "配置抄送人";
      this.open = true
    }
  }
};
</script>
